﻿using NUnit.Framework;
using ServiceStack.Common.Tests.Models;
using ServiceStack.OrmLite.Tests;

namespace ServiceStack.OrmLite.PostgreSQL.Tests
{
    public class OrmLiteDropTableWithNamingStrategyTests
        : OrmLiteTestBase
    {
        public OrmLiteDropTableWithNamingStrategyTests() : base(Dialect.PostgreSql) { }

        [Test]
        public void Can_drop_TableWithNamigStrategy_table_PostgreSqlNamingStrategy()
        {
            using (new TemporaryNamingStrategy(new PostgreSqlNamingStrategy()))
            using (var db = OpenDbConnection())
            {
                db.CreateTable<ModelWithOnlyStringFields>(true);
                db.DropTable<ModelWithOnlyStringFields>();
                Assert.False(db.TableExists("model_with_only_string_fields"));
            }
        }
    }
}